"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var autoBind = require("auto-bind");
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var graphql_codegen_typescript_1 = require("graphql-codegen-typescript");
var TypeScriptResolversVisitor = /** @class */ (function (_super) {
    __extends(TypeScriptResolversVisitor, _super);
    function TypeScriptResolversVisitor(pluginConfig, schema) {
        var _this = _super.call(this, pluginConfig, {
            avoidOptionals: pluginConfig.avoidOptionals || false,
            immutableTypes: pluginConfig.immutableTypes || false
        }, schema) || this;
        autoBind(_this);
        _this.setVariablesTransformer(new graphql_codegen_typescript_1.TypeScriptOperationVariablesToObject(_this.config.scalars, _this.convertName, _this.config.avoidOptionals, _this.config.immutableTypes));
        return _this;
    }
    TypeScriptResolversVisitor.prototype.formatRootResolver = function (schemaTypeName, resolverType) {
        return schemaTypeName + "?: " + resolverType + ",";
    };
    TypeScriptResolversVisitor.prototype.getRootResolver = function () {
        return _super.prototype.getRootResolver.call(this)
            .replace('};', '} & { [typeName: string] : { [ fieldName: string ]: ( Resolver<any, any, Context, any> | SubscriptionResolver<any, any, Context, any> ) } };');
    };
    TypeScriptResolversVisitor.prototype.getAllDirectiveResolvers = function () {
        return _super.prototype.getAllDirectiveResolvers.call(this)
            .replace('};', '} & { [directiveName: string]: DirectiveResolverFn<any, any, Context, any> };');
    };
    TypeScriptResolversVisitor.prototype.clearOptional = function (str) {
        if (str.startsWith('Maybe')) {
            return str.replace(/Maybe<(.*?)>/, '$1');
        }
        return str;
    };
    TypeScriptResolversVisitor.prototype.ListType = function (node) {
        return "Maybe<" + _super.prototype.ListType.call(this, node) + ">";
    };
    TypeScriptResolversVisitor.prototype.wrapWithListType = function (str) {
        return (this.config.immutableTypes ? 'ReadonlyArray' : 'Array') + "<" + str + ">";
    };
    TypeScriptResolversVisitor.prototype.NamedType = function (node) {
        return "Maybe<" + _super.prototype.NamedType.call(this, node) + ">";
    };
    TypeScriptResolversVisitor.prototype.NonNullType = function (node) {
        var baseValue = _super.prototype.NonNullType.call(this, node);
        return this.clearOptional(baseValue);
    };
    return TypeScriptResolversVisitor;
}(graphql_codegen_visitor_plugin_common_1.BaseResolversVisitor));
exports.TypeScriptResolversVisitor = TypeScriptResolversVisitor;
//# sourceMappingURL=visitor.js.map